/*
        tokenreader.cpp
        Mar. 21st, 2006
        Joris Roos <jorisr@gmx.de>
        TokenReader main module
*/

#include "tokenreader.h"

char* tokbuf;
int tokbuf_l;

char* newFileName(char*);

int main(int argsc, char** argsv)
{
    int c = 0;
    bool show = true;
    char tmp[BUFSIZE];
    
    printf("(c) Joris Roos, 2006\nContact: jorisr@gmx.de\n\n");

    if (argsc == 1) printf("Usage: TokenReader <file1> <file2> ... <filen>\n");

    for (int a = 1; a < argsc; a++)
        if (!strcmp(argsv[a], "-n")) show = false;
        else if (loadTokenFile(argsv[a]))
            if (writeASCIIFile(newFileName(argsv[a]))) 
            { c++; 
              if (show) {
                /* if '-n' was not provided, show file with notepad */
                sprintf(tmp, "notepad %s", newFileName(argsv[a])); 
                system(tmp);
              }
            }

    printf("%i file(s) successfully converted.\n", c);
    return 0;
}

char* newFileName(char* old)
{
    int old_l = strlen(old);
    /* create buffer for new file name */
    char* newfile = (char*)malloc(old_l+5);
    strcpy(newfile, old);
    int a;
    /* look for '.' in the file name */
    for (a = 0; a < old_l; a++)
        if (newfile[a] == '.') break;
    /* set extension to '.txt' */
    newfile[a]   = '.';
    newfile[a+1] = 't';
    newfile[a+2] = 'x';
    newfile[a+3] = 't';
    newfile[a+4] = 0;
    return newfile;
}

void prog_die() { freeTokBuf(); exit(1); }

void freeTokBuf() { free(tokbuf); tokbuf_l = (int)(tokbuf = 0); }

/* Last Edit: Mar. 22nd, 2006 */
